import { DefaultAction, Subscription } from '../types/form';
export interface FormState<T> {
    values: T;
    errors: Record<keyof T, string>;
    touched: Record<keyof T, boolean>;
}
declare class FormControl<T, ActionType = DefaultAction> {
    private formState;
    private readonly reducer;
    private subscription;
    constructor(state: T, reducer: (state: FormState<T>, action: ActionType) => FormState<T>);
    dispatch: (action: ActionType) => void;
    addSubscription: (sub: Subscription<FormState<T>>) => (() => void);
    removeSubscription: (sub: Subscription<FormState<T>>) => void;
    getState: () => FormState<T>;
    private notifySubscriber;
}
export declare const createFormControl: <T, ActionType = DefaultAction>(initialForm: T, reducer: (state: FormState<T>, action: ActionType) => FormState<T>) => FormControl<T, ActionType>;
export {};
